# Canon warns of Wi-Fi security risks when discarding inkjet printers
## Canon is warning users of home, office, and large format inkjet printers that their Wi-Fi connection settings stored in the devices' memories are not wiped, as they should, during initialization, allowing others to gain access to the data.
## Information:

+ Link: https://www.bleepingcomputer.com/news/security/canon-warns-of-wi-fi-security-risks-when-discarding-inkjet-printers/
+ Source: Bleeping Computer
+ Author: Bill Toulas
+ Date published: 31 July 2023, 12:51
+ Date scraped: 31 July 2023, 17:01

## Article:
![Main article image](https://www.bleepstatic.com/content/hl-images/2023/07/31/canon.jpg)



Canon is warning users of home, office, and large format inkjet printers that their Wi-Fi connection settings stored in the devices' memories are not wiped, as they should, during initialization, allowing others to gain access to the data.


This flaw could introduce a security and privacy risk for impacted users if the printer memory is extracted by repair technicians, temporary users, or future buyers of the devices, allowing them to get the connection details for your Wi-FI network.

Recommended by.fi-display-outer { float: right; position: relative; left: -13px;}.fi-display-outer .ob-text, .fi-display-outer .ob-logo {display: none !important;}.fi-display-outer .ob-ad-choices {padding: 0 !important;margin: 2px 0 !important; border-left: none !important;}


The specific information stored in a Canon printer varies depending on the model and configuration but generally includes the network SSID, the password, network type (WPA3, WEP, etc.), assigned IP address, MAC address, and network profile.


The exposure of this sensitive Wi-Fi connection information could help a malicious third-party gain unauthorized network access to a Canon printer user's network that the printer was connected to.


From there, the attacker can access shared resources, steal data, or launch other privacy-invading attacks leveraging additional vulnerabilities.


The list of Canon printers impacted by this issue is too extensive to include, comprising 196 inkjet, business inkjet, and large-format inject printer models from the E, G, GX, iB, iP, MB, MG, MX, PRO, TR, TS, and XK series.


The vendor has [published a separate document](https://canon.a.bigcontent.io/v1/static/affected-models_20230731_d04c0d9895124b65acd21ca68357dcdc) to help users check if the data retention problem impacts their printer models.


Canon suggests owners of impacted printers first wipe their Wi-FI settings before a third party has access to the printer, such as when you are repairing the device or giving/selling it to another person.


The [security advisory](http://psirt.canon/advisory-information/cp2023-003/) provides the following instructions on wiping Wi-FI settings:


1. Reset all settings (Reset settings ‐> Reset all)
2. Enable the wireless LAN
3. Reset all settings one more time

For models that do not have the 'Reset all' function in the settings menu, users are advised to follow these steps instead:


1. Reset LAN settings
2. Enable the wireless LAN
3. Reset LAN settings one more time

If these instructions are not applicable to your printer model, Canon recommends referring to the operation manual that came with your device.


Another good security precaution would be to keep printers on networks isolated from valuable assets so that attackers won't be able to access important devices even if that network is compromised.


Finally, apply the available firmware updates for your printer model, and turn off services such as cloud printing or remote management interfaces if they're not needed.





## Tags:


### Autogenerated tags:
[[wi-fi]] [[inkjet]]
